VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   Caption         =   ""
   ClientHeight    =   3855
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   3855
   LinkTopic       =   "Form1"
   ScaleHeight     =   257
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   257
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrColor 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   0
      Top             =   3480
   End
   Begin VB.PictureBox pbGame 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   3615
      Left            =   120
      ScaleHeight     =   3615
      ScaleWidth      =   3615
      TabIndex        =   0
      Top             =   120
      Width           =   3615
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Const cellWidth = 30
Private Const cellHeight = 30

Private gameField() As Integer
Private emptyCellX As Integer
Private emptyCellY As Integer
Private redCellX As Integer
Private redCellY As Integer
Private colorStage As Integer

Private Sub Form_Load()
    
    pbGame.Scale (0, 0)-(4, 4)
    pbGame.FillStyle = 0
    pbGame.FillColor = vbWhite
    StartGame
    
End Sub

Private Sub StartGame()
    
    gameField = GenerateNew(emptyCellX, emptyCellY)
    pbGame.Refresh
    
End Sub

Private Sub pbGame_Paint()

    Dim x As Integer, y As Integer
    Dim toPrint As String
    
    For y = 1 To 4
        For x = 1 To 4
            DrawCell x, y
        Next x
    Next y

End Sub

Private Sub DrawCell(x As Integer, y As Integer)

    pbGame.Line (x - 1, y - 1)-(x, y), , B
    If gameField(x, y) <> 16 Then
        toPrint = gameField(x, y)
        pbGame.CurrentX = x - pbGame.TextWidth(toPrint) / 2 - 0.5
        pbGame.CurrentY = y - pbGame.TextHeight(toPrint) / 2 - 0.5
        pbGame.Print toPrint
    End If
    
End Sub

Private Sub pbGame_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

    Dim fieldX As Integer, fieldY As Integer
    
    fieldX = Int(x) + 1
    fieldY = Int(y) + 1
    
    If Abs(fieldX - emptyCellX) + Abs(fieldY - emptyCellY) = 1 Then
        'Swap
        gameField(fieldX, fieldY) = gameField(fieldX, fieldY) + gameField(emptyCellX, emptyCellY)
        gameField(emptyCellX, emptyCellY) = gameField(fieldX, fieldY) - gameField(emptyCellX, emptyCellY)
        gameField(fieldX, fieldY) = gameField(fieldX, fieldY) - gameField(emptyCellX, emptyCellY)
        
        DrawCell fieldX, fieldY
        DrawCell emptyCellX, emptyCellY
        
        emptyCellX = fieldX
        emptyCellY = fieldY
        
        If IsFinished Then
            If MsgBox("Congratulations! Another game?", vbYesNo, "Win!") = vbNo Then
                End
            Else
                StartGame
            End If
        End If
        
        
    Else
        redCellX = fieldX
        redCellY = fieldY
        colorStage = 0
        tmrColor.Enabled = True
        pbGame.Refresh
    End If

End Sub

Private Function IsFinished() As Boolean

    Dim x As Integer, y As Integer, c As Integer
    
    c = 1
    For y = 1 To 4
        For x = 1 To 4
            If gameField(x, y) <> c Then
                IsFinished = False
                Exit Function
            End If
            c = c + 1
        Next x
    Next y
    
    IsFinished = True

End Function

Private Sub tmrColor_Timer()

    colorStage = colorStage + 4
    pbGame.FillColor = RGB(255, 25 * colorStage, 25 * colorStage)
        
    If colorStage = 12 Then
        pbGame.FillColor = vbWhite
        tmrColor.Enabled = False
    End If
    
    DrawCell redCellX, redCellY
    pbGame.FillColor = vbWhite
    
End Sub
